module InfiniteLists where

-- | construct a name generator
--
-- names = ["a".."z", "a1".."z1", "a2".."z2", ...]

names :: [String]
names = undefined


-- | constructs the infinite sequence
-- of fibonacci numbers in linear time
--
-- fibs = [0, 1, 1, 2, 3, 5, 8, ...]

fibs :: [Integer]
fibs = undefined

-- ----------------------------------------
--
-- | naive prime number generator with
-- sieve of Eratosthenes and a recursive
-- sieve operation

primes :: [Integer]
primes = undefined

-- ----------------------------------------
--
-- | difference lists
-- compute the list of differences of
-- all neighbours in a list

diff :: Num a => [a] -> [a]
diff xs = undefined

-- some tests

fibs'diff :: [Integer]
fibs'diff = diff fibs

primes'diff :: [Integer]
primes'diff = diff primes

squares :: [Integer]
squares = map (\x -> x * x) [0..]

squares'diff :: [Integer]
squares'diff = diff squares

squares'diff2 :: [Integer]
squares'diff2 = diff squares'diff

-- ----------------------------------------
--
-- | the hamiltonian sequence is the ordered sequence
-- of natural numbers which are multiples of 2 or 3 or 5
--
-- Implementation: the 3 lists of multiples of 2, 3 and 5
-- are merged together with a @merges@ function.
--
-- The direct solution is

hamilton' :: [Integer]
hamilton'
  = filter
    (\ i ->    i `mod` 2 == 0
            || i `mod` 3 == 0
            || i `mod` 5 == 0
    ) [0..]

-- | @hamilton@ by merging sequences

hamilton :: [Integer]
hamilton
  = merges' [is2, is3, is5]
    where
      is2 = undefined
      is3 = undefined
      is5 = undefined

merge :: [Integer] -> [Integer] -> [Integer]
merge = undefined

-- | @merges@ takes a list of lists of ascending integers
-- and merges these lists into a single sorted list without any duplicates
-- direct impl

merges :: [[Integer]] -> [Integer]
merges = undefined

-- | @merges@ with a fold

merges' :: [[Integer]] -> [Integer]
merges' = undefined    -- after chapter about folds

-- ----------------------------------------
